import {
  ChevronDownIcon,
  ChevronLeftIcon,
  ChevronRightIcon,
  DoubleArrowLeftIcon,
  DoubleArrowRightIcon,
} from '@radix-ui/react-icons'

import * as React from 'react'
import { DayButton, DayPicker, getDefaultClassNames } from 'react-day-picker'

import { Button, buttonVariants } from '@components/ui/button/button'
import { cn } from '@lib/utils'

function Calendar({
  className,
  classNames,
  showOutsideDays = true,
  captionLayout = 'label',
  buttonVariant = 'ghost',
  showYearNavigation = false,
  formatters,
  components,
  ...props
}: React.ComponentProps<typeof DayPicker> & {
  buttonVariant?: React.ComponentProps<typeof Button>['variant']
  showYearNavigation?: boolean
}) {
  const defaultClassNames = getDefaultClassNames()

  // Track last selected field for range mode
  const [rangeSelectionStep, setRangeSelectionStep] = React.useState<'from' | 'to'>('from')
  // Custom onDayClick for range mode to make sure 'from' and 'to' are always set alternatingly
  const handleDayClick = React.useCallback(
    (day: Date, modifiers: any, e: React.MouseEvent<Element>) => {
      if (props.mode === 'range') {
        const range = props.selected as { from?: Date; to?: Date } | undefined

        // Always start a new range when selecting 'from'
        if (rangeSelectionStep === 'from') {
          props.onSelect?.({ from: day, to: undefined }, day, modifiers, e)
          setRangeSelectionStep('to')
          return
        }

        // Only set 'to' if 'from' is set and not the same day
        if (rangeSelectionStep === 'to') {
          if (range?.from && day.getTime() !== range.from.getTime()) {
            props.onSelect?.({ from: range.from, to: day }, day, modifiers, e)
            setRangeSelectionStep('from')
          }
          return
        }
      } else {
        props.onDayClick?.(day, modifiers, e)
      }
    },
    [props, rangeSelectionStep],
  )

  // default year range if caption layout has year dropdown: 100 years past and 100 years future unless user overrides
  // with the dropdown a range is required. if we don't set it manually it will be -100 years until now which is impractical for future events
  let fromMonth: Date | undefined
  let toMonth: Date | undefined
  if (captionLayout === 'dropdown-years' || captionLayout === 'dropdown') {
    const nowYear = new Date().getFullYear()
    fromMonth = props.startMonth ?? new Date(nowYear - 100, 0)
    toMonth = props.endMonth ?? new Date(nowYear + 100, 11)
  }

  // controlled month state so we can programmatically change months (and years)
  const [currentMonth, setCurrentMonth] = React.useState<Date>(props.defaultMonth ?? props.month ?? new Date())
  React.useEffect(() => {
    if (props.month) {
      setCurrentMonth(props.month)
    }
  }, [props.month])

  const addMonths = (date: Date, months: number) => {
    const d = new Date(date)
    d.setMonth(d.getMonth() + months)
    if (fromMonth && d < fromMonth) {
      return fromMonth
    }
    if (toMonth && d > toMonth) {
      return toMonth
    }
    return d
  }

  return (
    <DayPicker
      month={currentMonth}
      onMonthChange={(m) => {
        setCurrentMonth(m)
        props.onMonthChange?.(m)
      }}
      showOutsideDays={showOutsideDays}
      className={cn(
        'bg-background group/calendar p-3 [--cell-size:--spacing(8)] [[data-slot=card-content]_&]:bg-transparent [[data-slot=popover-content]_&]:bg-transparent',
        String.raw`rtl:**:[.rdp-button\_next>svg]:rotate-180`,
        String.raw`rtl:**:[.rdp-button\_previous>svg]:rotate-180`,
        className,
      )}
      captionLayout={captionLayout}
      formatters={{
        formatMonthDropdown: (date) => date.toLocaleString('default', { month: 'short' }),
        ...formatters,
      }}
      classNames={{
        root: cn('w-fit', defaultClassNames.root),
        months: cn('flex gap-4 flex-col md:flex-row relative', defaultClassNames.months),
        month: cn('flex flex-col w-full gap-4', defaultClassNames.month),
        nav: cn('flex items-center gap-1 w-full absolute top-0 inset-x-0 justify-between', defaultClassNames.nav),
        button_previous: cn(
          buttonVariants({ variant: buttonVariant }),
          'size-(--cell-size) aria-disabled:opacity-50 p-0 select-none',
          defaultClassNames.button_previous,
        ),
        button_next: cn(
          buttonVariants({ variant: buttonVariant }),
          'size-(--cell-size) aria-disabled:opacity-50 p-0 select-none',
          defaultClassNames.button_next,
        ),
        month_caption: cn(
          'flex items-center justify-center h-(--cell-size) w-full px-(--cell-size)',
          defaultClassNames.month_caption,
        ),
        dropdowns: cn(
          'w-full flex items-center text-sm font-medium justify-center h-(--cell-size) gap-1.5',
          defaultClassNames.dropdowns,
        ),
        dropdown_root: cn(
          'relative has-focus:border-ring border border-input shadow-xs has-focus:ring-ring/50 has-focus:ring-[3px] rounded-md',
          defaultClassNames.dropdown_root,
        ),
        dropdown: cn('absolute bg-popover inset-0 opacity-0', defaultClassNames.dropdown),
        caption_label: cn(
          'select-none font-medium',
          captionLayout === 'label'
            ? 'text-sm'
            : 'rounded-md pl-2 pr-1 flex items-center gap-1 text-sm h-8 [&>svg]:text-muted-foreground [&>svg]:size-3.5',
          defaultClassNames.caption_label,
        ),
        table: 'w-full border-collapse',
        weekdays: cn('flex', defaultClassNames.weekdays),
        weekday: cn(
          'text-muted-foreground rounded-md flex-1 font-normal text-[0.8rem] select-none',
          defaultClassNames.weekday,
        ),
        week: cn('flex w-full mt-2', defaultClassNames.week),
        week_number_header: cn('select-none w-(--cell-size)', defaultClassNames.week_number_header),
        week_number: cn('text-[0.8rem] select-none text-muted-foreground', defaultClassNames.week_number),
        day: cn(
          'relative w-full h-full p-0 text-center [&:first-child[data-selected=true]_button]:rounded-l-md [&:last-child[data-selected=true]_button]:rounded-r-md group/day aspect-square select-none',
          defaultClassNames.day,
        ),
        range_start: cn('rounded-l-md bg-accent', defaultClassNames.range_start),
        range_middle: cn('rounded-none', defaultClassNames.range_middle),
        range_end: cn('rounded-r-md bg-accent', defaultClassNames.range_end),
        today: cn(
          'bg-accent text-accent-foreground rounded-md data-[selected=true]:rounded-none',
          defaultClassNames.today,
        ),
        outside: cn('text-muted-foreground aria-selected:text-muted-foreground', defaultClassNames.outside),
        disabled: cn('text-muted-foreground opacity-50', defaultClassNames.disabled),
        hidden: cn('invisible', defaultClassNames.hidden),
        ...classNames,
      }}
      // prefer startMonth/toMonth instead of deprecated fromYear/toYear
      startMonth={fromMonth}
      endMonth={toMonth}
      components={{
        // custom navigation: to add double-chevron year skip buttons
        Nav: ({ className }) => (
          <div className={cn('mt-0.5', className)}>
            <div className="flex items-center">
              {showYearNavigation && (
                <Button
                  aria-label="previous year"
                  variant={buttonVariant}
                  size="iconSm"
                  disabled={fromMonth && currentMonth <= fromMonth}
                  className={captionLayout === 'dropdown' ? 'size-6.5' : ''}
                  onClick={() => setCurrentMonth((m) => addMonths(m ?? new Date(), -12))}
                >
                  <DoubleArrowLeftIcon className="" />
                </Button>
              )}
              <Button
                aria-label="previous month"
                variant={buttonVariant}
                size="iconSm"
                disabled={fromMonth && currentMonth <= fromMonth}
                className={captionLayout === 'dropdown' ? 'size-6.5' : ''}
                onClick={() => setCurrentMonth((m) => addMonths(m ?? new Date(), -1))}
              >
                <ChevronLeftIcon />
              </Button>
            </div>

            <div className="flex items-center">
              <Button
                aria-label="next month"
                variant={buttonVariant}
                size="iconSm"
                disabled={toMonth && currentMonth >= toMonth}
                className={captionLayout === 'dropdown' ? 'size-6.5' : ''}
                onClick={() => setCurrentMonth((m) => addMonths(m ?? new Date(), 1))}
              >
                <ChevronRightIcon />
              </Button>
              {showYearNavigation && (
                <Button
                  aria-label="next year"
                  variant={buttonVariant}
                  size="iconSm"
                  disabled={toMonth && currentMonth >= toMonth}
                  className={captionLayout === 'dropdown' ? 'size-6.5' : ''}
                  onClick={() => setCurrentMonth((m) => addMonths(m ?? new Date(), 12))}
                >
                  <DoubleArrowRightIcon />
                </Button>
              )}
            </div>
          </div>
        ),
        // prettier-ignore
        Root: ({ className, rootRef, ...props }) => {     //NOSONAR - default shadeCn
          return <div data-slot="calendar" ref={rootRef} className={cn(className)} {...props} />
        },
        // prettier-ignore
        Chevron: ({ className, orientation, ...props }) => {      //NOSONAR - default shadeCn
          if (orientation === 'left') {
            return <ChevronLeftIcon className={cn('size-4', className)} {...props} />
          }

          if (orientation === 'right') {
            return <ChevronRightIcon className={cn('size-4', className)} {...props} />
          }

          return <ChevronDownIcon className={cn('size-4', className)} {...props} />
        },
        DayButton: CalendarDayButton,
        // prettier-ignore
        WeekNumber: ({ children, ...props }) => {     //NOSONAR - default shadeCn
          return (
            <td {...props}>
              <div className="flex size-(--cell-size) items-center justify-center text-center">{children}</div>
            </td>
          )
        },
        ...components,
      }}
      onDayClick={handleDayClick}
      {...props}
    />
  )
}

function CalendarDayButton({ className, day, modifiers, ...props }: React.ComponentProps<typeof DayButton>) {
  const defaultClassNames = getDefaultClassNames()

  const ref = React.useRef<HTMLButtonElement>(null)
  React.useEffect(() => {
    if (modifiers.focused) {
      ref.current?.focus()
    }
  }, [modifiers.focused])

  return (
    <Button
      ref={ref}
      variant="ghost"
      size="icon"
      data-day={day.date.toLocaleDateString()}
      data-selected-single={
        modifiers.selected && !modifiers.range_start && !modifiers.range_end && !modifiers.range_middle
      }
      data-range-start={modifiers.range_start}
      data-range-end={modifiers.range_end}
      data-range-middle={modifiers.range_middle}
      className={cn(
        'data-[selected-single=true]:bg-primary data-[selected-single=true]:text-primary-foreground data-[range-middle=true]:bg-accent data-[range-middle=true]:text-accent-foreground data-[range-start=true]:bg-primary data-[range-start=true]:text-primary-foreground data-[range-end=true]:bg-primary data-[range-end=true]:text-primary-foreground group-data-[focused=true]/day:border-ring group-data-[focused=true]/day:ring-ring/50 dark:hover:text-accent-foreground flex aspect-square size-auto w-full min-w-(--cell-size) flex-col gap-1 leading-none font-normal group-data-[focused=true]/day:relative group-data-[focused=true]/day:z-10 group-data-[focused=true]/day:ring-[3px] data-[range-end=true]:rounded-md data-[range-end=true]:rounded-r-md data-[range-middle=true]:rounded-none data-[range-start=true]:rounded-md data-[range-start=true]:rounded-l-md [&>span]:text-xs [&>span]:opacity-70',
        defaultClassNames.day,
        className,
      )}
      {...props}
    />
  )
}

export { Calendar, CalendarDayButton }
